<?php
//--------------------------------
// configuration
//--------------------------------
$nLoginTimeOut = 15; // in minutes


//--------------------------------
// end configuration
//--------------------------------
require("login/dbTools.php");
require("login/correct_login.php3");
require("login/already_loged_in.php3");
require("login/login_maske.php3");

//----------------------------------------------------------------------------------------------    
// start login abfragen 
//----------------------------------------------------------------------------------------------

//-------------------------------------------------------------------
// schauen, ob strPostIdUser und strPostLoginCode existieren
//
// Attributes: 
// $strLoginId 
// $strLoginCode
//-------------------------------------------------------------------

if ($strPostLoginCode && $nPostIdUser)
{
   // echo "form empfangen<br>";
   //--------------------------------------------------
   // checken ob angaben auch in db
   //--------------------------------------------------
   $strTable = "tbAccessLog";
   $query = "SELECT * FROM $strTable WHERE strLoginCode = '$strPostLoginCode' AND idUser = '$nPostIdUser' AND dtLogoutTime = '0000-00-00 00:00:00'";
   // echo "$query<br>";
   $rows = db_query("$query");
   $num_rows = db_numrows($rows);
   if ($num_rows != 0 && $num_rows)
   {
      // echo "db eintrag gefunden!<br>";
	  $rowarray		= db_fetch_array($rows);
	  $idAccessLog		= $rowarray["id"];
	  $idUser		= $rowarray["idUser"];
	  $dtLoginTime		= $rowarray["dtLoginTime"];
	  $dtLoginCode		= $rowarray["dtLoginCode"];
	  $dtLastActivity	= $rowarray["dtLastActivity"];
	  $dtLogoutTime		= $rowarray["dtLogoutTime"];
      //-----------------------------------------------
      // strNickName herausfinden
      //-----------------------------------------------
      // echo "nickname herausfinden!<br>";
      $strNickName = db_get_field("strName", "dbo_tbUser", "id = '$idUser'");
      if ($strNickName)
      {
         // $strLoginMessage = "strLoginCode und idUser ueber FORM / URL!";
         // echo "nickname: $strNickName... ueber form ---> already_loged_in()<br>";
         already_loged_in();
      }
      else
      {
         if ($idUser > 0)
         {
            $strLoginStatus = "false";
            $strLoginMessage = "sorry, etwas stimmt mit dem account nicht. bitte neu einloggen!";    
            login_maske($micromusic3LoginCookie);
         }
         else
         {
            already_loged_in();
         }     
      }

   }

}

//-------------------------------------------------------------------------------------
// schauen, ob 
// $strPostLoginName und $strPostPasswort gesetzt sind (NO COOKIE) NO FORM/URL info
//-------------------------------------------------------------------------------------

if ($strPostLoginName && $strPostPasswort && !$strPostLoginCode && !$nPostIdUser)
{
   //---------------------------------------------------------------
   // echo "LoginName & PassWord ueberpruefen in dbo_tbUser<BR>";
   //---------------------------------------------------------------
   // idUser herausfinden
   //---------------------------------------------------------------
   $idUser = db_get_field("id", "dbo_tbUser", "STRCMP(strName, '$strPostLoginName') = 0 AND STRCMP(strPassword,'$strPostPasswort') = 0");
   if ($idUser)
   {
      $strTable = "tbAccessLog";
      $query = "SELECT * FROM $strTable WHERE dtLastActivity > DATE_SUB( NOW(), INTERVAL $nLoginTimeOut MINUTE) AND idUser='$idUser' AND dtLogoutTime = '0000-00-00 00:00:00'";
      // echo "$query<br>";
      $rows = db_query("$query");
      $num_rows = db_numrows($rows);
      if ($num_rows > 0 && $strPostLoginName != "guest")
      {
         $idAccessLog      = db_get_field("id","tbAccessLog","dtLastActivity > DATE_SUB( NOW(), INTERVAL $nLoginTimeOut MINUTE) AND idUser='$idUser' AND dtLogoutTime = '0000-00-00 00:00:00'");
         $nPostIdUser      = $idUser;
         $strPostLoginCode = db_get_field("strLoginCode","tbAccessLog","dtLastActivity > DATE_SUB( NOW(), INTERVAL $nLoginTimeOut MINUTE) AND idUser='$idUser' AND dtLogoutTime = '0000-00-00 00:00:00'");
         already_loged_in();
      }
      else
      {
         correct_login();
      }
   }
   else
   {
      $strLoginStatus = "false";
      $strLoginMessage = "passwort oder username falsch!";
      login_maske($micromusic3LoginCookie);
      // echo "$strLoginMessage<br>";
   }
}

//----------------------------------------------------------------------------------------------------
// falls das cookie $micromusic3LoginCookie existiert... (und nichts anderes) 
//----------------------------------------------------------------------------------------------------
 
if ($micromusic3LoginCookie && !$strPostLoginName && !$strPostPasswort && !$strPostLoginCode && !$nPostIdUser && $strLoginStatus != "true")    
{
   //-------------------------------------------------------------------------------
   // echo "Cookie gefunden...<BR>";
   // echo "inhalt:$micromusic3LoginCookie<BR>";
   // ------------------------------------------------------------------------------
   // CookieDaten lesen
   //-------------------------------------------------------------------------------
   // $strLoginMessage = "Cookie gefunden...";
   $strCookieParts = explode("_",$micromusic3LoginCookie);
   $CkIdUser = $strCookieParts[0];
   $CkLoginCode = $strCookieParts[1];
   $CkLoginTime = $strCookieParts[2];
   // echo "id: $CkIdUser<BR>";
   // echo "code: $CkLoginCode<BR>";
   // echo "time: $CkLoginTime<BR>";

   //--------------------------------------------------------------------------------------
   // Schauen, ob es in tbAccessLog einen eintrag gibt mit $micromusic3LoginCookie infos
   //--------------------------------------------------------------------------------------

   $strTable = "tbAccessLog";
   $query = "SELECT * FROM $strTable WHERE strLoginCode = '$CkLoginCode' AND idUser='$CkIdUser' AND dtLogoutTime = '0000-00-00 00:00:00'";
   $rows = db_query("$query");
   $num_rows = db_numrows($rows);
   if ($num_rows != 0 && $num_rows)
   {
	  $rowarray		  = db_fetch_array($rows);
	  $idAccessLog    = $rowarray["id"];
	  $idUser		  = $rowarray["idUser"];
	  $dtLoginTime    = $rowarray["dtLoginTime"];
	  $strLoginCode    = $rowarray["strLoginCode"];
	  $dtLastActivity = $rowarray["dtLastActivity"];
      already_loged_in();
   }
   else 
   {
      // falls nein
      // echo "kein passender db eintrag gefunden!<BR>";
      $strNickName = db_get_field("strName","dbo_tbUser","id = '$CkIdUser'");
      // $strLoginMessage = "du bist nicht mehr eingeloggt!";
      $strLoginStatus = "false";
      login_maske($micromusic3LoginCookie);
   }
}	

//-------------------------------------------------------------------------------------------
// sicherheits check
//-------------------------------------------------------------------------------------------
if (!idUser || $idUser == 0 || $strLoginStatus == "false")
{
   login_maske($micromusic3LoginCookie);
}

// echo "bestimme userdaten<br>";
$strTable = "dbo_tbUser";
$query = "SELECT * FROM $strTable WHERE id = '$idUser'";
$rows = db_query("$query");
$num_rows = db_numrows($rows);
$rowarray  	   = db_fetch_array($rows);
$nUploaded         = $rowarray["intUploaded"];
$nDownloaded       = $rowarray["intDownloaded"];
$nUserLevel        = $rowarray["nLevel"];
$strEmail          = $rowarray["strEmail"];
   
// $nUploaded   = db_get_field("intUploaded","dbo_tbUser","id = '$idUser'");
// $nDownloaded = db_get_field("intDownloaded","dbo_tbUser","id = '$idUser'");
// $nUserLevel  = db_get_field("nLevel","dbo_tbUser","id = '$idUser'");
// $strEmail    = db_get_field("strEmail","dbo_tbUser","id = '$idUser'");

$dtLoginTime = db_get_field("dtLoginTime","tbAccessLog","strLoginCode = '$strLoginCode'");
$strURLLoginInfo = "strPostLoginCode=$strLoginCode&nPostIdUser=$idUser";


//--------------------------------------
// Last Login bestimmen
//--------------------------------------
$dtLastLogin = db_get_field("dtLastLogin","dbo_tbUser","id = '$idUser'");


if ($idUser < 0)
{
   $strNickName = "guest" . -($idUser+1-1);
   
}
?>