<?php
//----------------------------------------------------------------------------
//	 Project:	Micromusic
//	 Module:	linkz
//	 File:		linkz/dbtools.php3
//	 System:	SuSe Linux 6.1, php3
//----------------------------------------------------------------------------
//	 Author:	arsa
//	 Copyright 	1999 by micromusic.org, All Rights Reserved
//----------------------------------------------------------------------------
//	 Last modification:
//	 $Author: $
//	 $Modtime: $              (VSS revision history at end of file)
//	 $Revision: $
//----------------------------------------------------------------------------

$flagged = "1";
include "config.php";
/*
$g_strHost	= "localhost";
$g_strDbName = "microswapper";
$g_strLogin	= "microswapper";
$g_strPwd	= "microswapper";
*/
//---------------------------------------------------------------------------------
function report_error($e_func,$e_number,$e_msg)
//---------------------------------------------------------------------------------
{
	global $flagged;
	if (! $flagged) {
		LogIt("ERR","$e_func","Error $e_number: $e_msg");
	?>
		<SCRIPT LANGUAGE="JavaScript">
		alert("MySQL Error # <? echo $e_number ?> in function <? echo $e_func ?>\n<? echo $e_msg ?>");
		</SCRIPT>
	<?
		$flagged=1;
	}
}

//----------------------------------------------------------------------------
// Description:
// 		Connects to given database on given host, with given login and
// 		password.
// Usage:
// 		Can be used from any file that needs a connection to the database.
// 		If all 4 parameters needed for the connection are the same, they
// 		can be hard-coded in this file. The connection will be automatically
// 		established.
//----------------------------------------------------------------------------
class CDatabase
//----------------------------------------------------------------------------
{
	var $m_strHost;
	var $m_strDbName;
	var $m_strLogin;
	var $m_strPwd;
	var $m_DbLink;

	//----------------------------------------------------------------------------
	// Accessors
	function GetHostName()		{ return $this->m_strHost;   }
	function GetDbName()		{ return $this->m_strDbName; }
	function GetLoginName() 	{ return $this->m_strLogin;  }
	function GetDbLink() 		{ return $this->m_DbLink;  }

	//----------------------------------------------------------------------------
	// Constructor
	function CDatabase($p_strHost, $p_strDbName, $p_strLogin, $p_strPwd)
	{
		$this->m_strHost = $p_strHost;
		$this->m_strDbName = $p_strDbName;
		$this->m_strLogin = $p_strLogin;
		$this->m_strPwd = $p_strPwd;
		$this->m_DbLink = "";			// Ensure to be empty
		
		// TODO: Check if all variables are not empty

        // echo "CDatabase constructor<br>";
		// echo "host: $this->m_strHost<br>";
		// echo "database: $this->m_strDbName<br>";
		// echo "login: $this->m_strLogin<br>";
		// echo "pwd: $this->m_strPwd</FONT><br>";
	}
	//----------------------------------------------------------------------------
	//	Description:
	// 		Try to establish the connection to the database.
	// 	Return value:
	// 		handle to the established connection
	// 		Note:	Caller function must test for the integrity of returned value.
	//----------------------------------------------------------------------------
	function Connect()
	{
		// echo "Connecting the database...";
		$this->m_DbLink = mysql_connect($this->m_strHost, $this->m_strLogin, $this->m_strPwd);
		$test = mysql_connect($this->m_strHost, $this->m_strLogin, $this->m_strPwd);
		if ($test == 0)
		{
			// echo "The database is currently offline! Please try again later.";
			exit;
		}
		return $this->m_Dblink;
	}
}

//---------------------------------------------------------------------------------
function db_query($qstring)
//---------------------------------------------------------------------------------
{
    global $g_strDbName;
    
	$result = mysql($g_strDbName,"$qstring");
	if (mysql_errno())
	{
		$foostring = addslashes($qstring);
//		LogIt("ERR","db_query","$qstring");
		report_error("db_query",mysql_errno(),mysql_error(),"Query was: $foostring");
	}
	return $result;
}

//---------------------------------------------------------------------------------
function db_numrows($qhandle)
//---------------------------------------------------------------------------------
{
    global $g_strHost;
    global $g_strDbName;
    global $g_strLogin;
    global $g_strPwd;
    
	$result = mysql_numrows($qhandle);
	if (mysql_errno()) {
		report_error("db_numrows",mysql_errno(),mysql_error());
	}
	return $result;
}

	
//---------------------------------------------------------------------------------
function db_affected_rows($qhandle)
//---------------------------------------------------------------------------------
{
    global $g_strHost;
    global $g_strDbName;
    global $g_strLogin;
    global $g_strPwd;
    
	$result = mysql_affected_rows($qhandle);
	if (mysql_errno()) {
		report_error("db_numrows",mysql_errno(),mysql_error());
	}
	return $result;
}


//---------------------------------------------------------------------------------
function db_result($qhandle,$row,$field)
//---------------------------------------------------------------------------------
{
	global $g_strDbName;
	if ($qhandle == 0)
	{
		report_error("db_result",mysql_errno(),"Attempt to fetch from empty handle.");
	}
	else
	{
		$result = mysql_result($qhandle, $row, $field);
		if (mysql_errno())
		{
			report_error("db_result", mysql_errno(), mysql_error());
		}
	}
	return $result;
};

//---------------------------------------------------------------------------------
function db_fetch_array($qhandle)
//---------------------------------------------------------------------------------
{
	if ($qhandle == 0)
	{
		report_error("db_fetch_array",mysql_errno(),"Attempt to fetch from empty handle.");
	}
	else
	{
		$result = mysql_fetch_array($qhandle);
		if (mysql_errno()) {
			report_error("db_fetch_array",mysql_errno(),mysql_error());
		}
	}
	return $result;
}

function db_get_field($strFieldName, $strTable, $strMiniQuery)
//---------------------------------------------------------------------------------
{
   global $g_strDbName;

   $query = "SELECT $strFieldName FROM $strTable WHERE $strMiniQuery";
   // echo "query von db_get_field: $query<br>";
   $rows = db_query("$query");
   $num_rows = db_numrows($rows);
   if ($num_rows != 0 && $num_rows)
   {
	  $rowarray		  = db_fetch_array($rows);
	  $result		  = $rowarray["$strFieldName"];
   }
   
   return $result;
}


//---------------------------------------------------------------------------------
function CheckStyles($p_strStyleName)
//---------------------------------------------------------------------------------
{
    // Variables defined in dbtools.php3
    global $database;
 	$strTable = "dbo_tbStyles";

 	// Select all records from table dbLinks
 	$rows = db_query("SELECT * FROM $strTable WHERE strName = '$p_strStyleName'");
    if ($rows)
    {
 	   $num_rows = db_numrows($rows);
 	   if ($num_rows)
       {
			// Record already present.
			return;
 	   }
    }
    // Compose insert query
 	$strInsertQuery = "INSERT INTO $strTable (id, strName, strDescription) ";
 	$strInsertQuery .= "VALUES ('', '$p_strStyleName', '$p_strStyleName')";
	// echo "database: $database, Style insert query: $strInsertQuery<BR>";

	$status = mysql($database, $strInsertQuery);

	if (!$status)
    {
       echo "could not insert style into dbo_tbStyles.<BR>";
    }
}

//----------------------------------------------------------------------------
// Description:
// Usage:
//----------------------------------------------------------------------------
class CDownloadStatistic
//----------------------------------------------------------------------------
{
	var $m_id;
	var $m_idUser;
	var $m_idItemSound;
	var $m_dtDownloadTime;
	var $m_idDownloadAreaCode;

	//----------------------------------------------------------------------------
	// Accessors
	function GetId()					{ return "$this->m_id";   }
	function GetIdUser()				{ return $this->m_idUser; }
	function GetIdItemSound() 			{ return $this->m_idItemSound;  }
	function GetDownloadTime() 			{ return $this->m_dtDownloadTime;  }
	function GetDownloadAreaCode() 		{ return $this->m_idDownloadAreaCode;  }

	function SetId($id)									{ $this->m_id = $id;   }
	function SetIdUser($idUser)							{ $this->m_idUser = $idUser; }
	function SetIdItemSound($idItemSound) 				{ $this->m_idItemSound = $idItemSound;  }
	function SetDownloadTime($dtDownloadTime) 			{ $this->m_dtDownloadTime = $dtDownloadTime;  }
	function SetDownloadAreaCode($idDownloadAreaCode) 	{ $this->m_idDownloadAreaCode = $idDownloadAreaCode;  }

	//----------------------------------------------------------------------------
	// Constructor
	function CDownloadStatistic($rowarray)
	{
		$this->m_id = $rowarray["id"];
		$this->m_idUser = $rowarray["idUser"];
		$this->m_idItemSound = $rowarray["idItemSound"];
		$this->m_dtDownloadTime = $rowarray["dtDownloadTime"];
		$this->m_idDownloadAreaCode = $rowarray["idDownloadAreaCode"];

/*      echo "CDownloadStatistic constructor<br>";
		echo "id: $this->m_id<br>";
		echo "idUser: $this->m_idUser<br>";
		echo "idItemSound: $this->m_idItemSound<br>";
		echo "dtDownloadTime: $this->m_dtDownloadTime<br>";
		echo "idDownloadAreaCode: $this->m_idDownloadAreaCode</FONT><br>";
 */
	}
	//----------------------------------------------------------------------------
	//	Description:
	// 	Return value:
	//----------------------------------------------------------------------------
}

//----------------------------------------------------------------------------
class CDownloadInfo
//----------------------------------------------------------------------------
{
	var $m_id;
	var $m_dtUploadDate;
	var $m_idUserId;
	var $m_strFileName;
	var $m_strPath;
	var $m_strAuthor;
	var $m_strInfos;
	var $m_strStyle;
	var $m_strFileTitle;
	var $m_strFileType;
	var $m_intFileSize;

	//----------------------------------------------------------------------------
	// Accessors
	function GetId()					{ return $this->m_id;   }
	function GetIdUser()				{ return $this->m_idUser; }
	function GetUploadDate() 			{ return $this->m_dtUploadDate;  }
	function GetFileName() 				{ return $this->m_strFileName;  }
	function GetPath() 					{ return $this->m_strPath;  }
	function GetAuthor()				{ return $this->m_strAuthor; }
	function GetInfos() 				{ return $this->m_strInfos;  }
	function GetStyle() 				{ return $this->m_strStyle;  }
	function GetFileTitle() 			{ return $this->m_strFileTitle;  }
	function GetFileSize() 				{ return $this->m_intFileSize;  }

	function SetId($id)						{ $this->m_id = $id;   }
	function SetIdUser($idUser)				{ $this->m_idUser = $idUser; }
	function SetUploadDate($dtUploadDate) 	{ $this->m_dtUploadDate = $dtUploadDate;  }
	function SetFileName($strFileName) 		{ $this->m_strFileName = $strFileName;  }
	function SetPath($strPath) 				{ $this->m_strPath = $strPath;  }
	function SetAuthor($strAuthor)			{ $this->m_strAuthor = $strAuthor; }
	function SetInfos($strInfos) 			{ $this->m_strInfos = $strInfos;  }
	function SetStyle($strStyle) 			{ $this->m_strStyle = $strStyle;  }
	function SetFileTitle($strFileTitle) 	{ $this->m_strFileTitle = $strFileTitle;  }
	function SetFileSize($intFileSize) 		{ $this->m_intFileSize = $intFileSize;  }

	//----------------------------------------------------------------------------
	// Constructor
	function CDownloadInfo($rowarray)
	{
		$this->GetMemberFromRowarray($rowarray);
		$this->ShowMembers();
	}

	//----------------------------------------------------------------------------
	// Constructor
	function GetMemberFromRowarray($rowarray)
	{
		$this->m_id = $rowarray["id"];
		$this->m_idUser = $rowarray["idUser"];
		$this->m_dtUploadDate = $rowarray["dtUploadDate"];
		$this->m_strFileName = $rowarray["strFileName"];
		$this->m_strPath = $rowarray["strPath"];
		$this->m_strAuthor= $rowarray["strAuthor"];
		$this->m_strInfos = $rowarray["strInfos"];
		$this->m_strStyle = $rowarray["strStyle"];
		$this->m_strFileTitle = $rowarray["strFileTitle"];
		$this->m_intFileSize = $rowarray["intFileSize"];

		$this->ShowMembers();
	}

	//----------------------------------------------------------------------------
	function ShowMembers()
	//----------------------------------------------------------------------------
	{
      	echo "CDownloadInfo constructor<br>";
		echo "id: $this->m_id<br>";
		echo "idUser: $this->m_id<br>";
		echo "dtUploadDate: $this->m_dtUploadDate<br>";
		echo "strFileName: $this->m_strFileName<br>";
		echo "strPath: $this->m_strPath><br>";
		echo "strAuthor: $this->m_strAuthor<br>";
		echo "strInfos: $this->m_strInfos<br>";
		echo "strStyle: $this->m_strStyle<br>";
		echo "strInfos: $this->m_strInfos<br>";
		echo "strFileTitle: $this->m_strFileTitle<br>";
		echo "strFileType: $this->m_strFileType<br>";
		echo "strFileSize: $this->m_strFileSize<br>";
	}

	//----------------------------------------------------------------------------
	// fill members with values from the database record
	//----------------------------------------------------------------------------
	function Read ()
	//----------------------------------------------------------------------------
	{
/*
		global $g_strHost;
		global $g_strDbName;
		global $g_strLogin;
		global $g_strPwd;
		global $g_arLinkFields;
		$strTableUploadz = "dbo_tbUploadz";

 		// Connect to the database
		$db = new CDatabase($g_strHost, $g_strDbName, $g_strLogin, $g_strPwd);
		$dblink = $db->Connect();
  */
		echo "function Read: idUploadId = $idUploadId<br>";

		$rowsUploadz = db_query("SELECT * FROM $strTableUploadz WHERE intUploadId = 'idUploadId'");
		if (!$rowsUploadz)
		{
			echo "upload record not found<br>";
			return;
		}
		$rowarray = db_fetch_array($rowsUploadz);
		$this->GetMemberFromRowarray($rowarray);
	}

	//----------------------------------------------------------------------------
	// Implement any statistic updates here
	//----------------------------------------------------------------------------
	function UpdateStatistics()
	//----------------------------------------------------------------------------
	{
/*
		//-----------------------------------------
		// set intAccessed of soundfile +1
		//-----------------------------------------
		$query = "SELECT intAccessed FROM dbo_tbSoundFilez WHERE intSoundId = '$intSoundId'";
		// echo "$query";
		$result = mysql($database,$query);
		$intOldAccess = mysql_result($result,0,"intAccessed");
		$intNewAccess = $intOldAccess + 1;

		//-----------------------------------------
		// set intAccessed of soundfile +1
		//-----------------------------------------
		$query = "UPDATE dbo_tbSoundFilez SET intAccessed='$intNewAccess' WHERE intSoundId='$intSoundId'";
		// echo "$query<BR>";
		$status = mysql($database,$query);
		if (!$status)
		{
    		echo "could not encrease access value. sorry! (no entry)<BR>";
    		exit;
		}
 */
	}

	//----------------------------------------------------------------------------
	// Implement any checking here and statistic updates here
	//----------------------------------------------------------------------------
	function CheckDownload()
	//----------------------------------------------------------------------------
	{
/*
		//------------------------------------------------
		// checken ob schon in dbo_tbUserInfo eingetragen
		//------------------------------------------------
		$query = "SELECT id FROM dbo_tbUserInfo WHERE id = '$intUserId'";
		// echo "$query<br>";
		$result = mysql($database,$query);
		$test = mysql_numrows($result);
		// echo "$test<br>";
		if ($test != 0)
		{
    		//------------------------------------
    		// get old intUploaded value
    		//------------------------------------
    		$query = "SELECT intDownloaded FROM dbo_tbUserInfo WHERE id = '$intUserId'";
    		$result = mysql($database,$query);
    		$intDownloadedCurrent = mysql_result($result,0,"intDownloaded");
    		//------------------------------------
    		// add new and insert into table
    		//------------------------------------
    		$intDownloaded = $intDownloadedCurrent + $intFileSize;
    		$query = "UPDATE dbo_tbUserInfo SET intDownloaded=$intDownloaded WHERE id='$intUserId'";
    		// echo "$query<BR>";
    		$status = mysql($database,$query);
    		if (!$status)
    		{
        		echo "download blocked. sorry! (no entry)<BR>";
        		exit;
    		}
		}
		else
		{
    		$query = "INSERT INTO dbo_tbUserInfo (id, intDownloaded) ";
    		$query .= "VALUES ($intUserId, $intFileSize)";
    		// echo "$query<BR>";
    		$status = mysql($database,$query);
    		if (!$status)
    		{
        		echo "download blocked. sorry!<BR>";
        		exit;
    		}
		}
 */
	}
}

//---------------------------------------------------------------------------------
function GetStatistics($p_idItem, $p_idUser, $p_idItemSound, $p_dtDownloadTime, $p_idAreaCode)
//---------------------------------------------------------------------------------
{
	// Variables defined in dbtools.php3
	global $database;
	global $intUserId;
	$strTable = "dbo_tbDownloadStatistics";

 	// Select all records from table dbLinks
	$strInsertQuery = "";
 	$rows = db_query("SELECT * FROM $strTable WHERE id = '$p_idItem'");
    if (!$rows)
    {
		echo "stat record not found<br>";
    	// set intUserId = -1 if guest
    	if ($intUserId < 0) {$intUserId = -1;}

    	// Compose insert query:
		// INSERT INTO dbo_tbDownloadStatistics
		//		(id, idUser, idItemSound, dtDownloadTime, idDownloadAreaCode)
		//		VALUES ('1', '1', '1', '1999-11-05 00:01:24', '0')
		$strInsertQuery .= "INSERT INTO $strTable ";
 		$strInsertQuery .= "(id, idUser, idItemSound, dtDownloadTime, idDownloadAreaCode) ";
 		$strInsertQuery .= "VALUES('$p_idItem', '$p_idUser', '$p_idItemSound', ";

		if (!$p_dtDownloadTime)
 			$strInsertQuery .= "NOW(), '$p_idAreaCode')";
		else
			$strInsertQuery .= "'$p_dtDownloadTime', '$p_idAreaCode')";
    	// echo "Statistics insert query: $strInsertQuery<BR>";

    	$status = mysql($database, $strInsertQuery);
    	if (!$status)
       		echo "could not insert statistic into $strTable.<BR>";
	}
	// else
	// {
		// eventually update record
 	   // $num_rows = db_numrows($rows);
 	   // if ($num_rows)
       // {
			// Record already present. Update it only
      		// $strInsertQuery .= "UPDATE $strTable SET ";
			// Update fields whatever should be updated
			// $strInsertQuery .= "idUser = $p_idUser ";
			// $strInsertQuery .= "p_idItemSound = $p_idItemSound ";
			// $strInsertQuery .= "dtDownloadTime = $p_dtDownloadTime ";
			// $strInsertQuery .= "idAreaCode = $p_idAreaCode ";
			// $strInsertQuery .= "WHERE id = '$p_idItem'";
			// echo "Update statistic record.";
			// return;
 	   // }
	// }

 	// Select all records from table dbUploadz
 	$rows = db_query("SELECT * FROM $strTable WHERE id = '$p_idItem'");
    if ($rows)
	{
		$rowarray = db_fetch_array($rows);
/*
		$m_id = $rowarray["id"];
		$m_idUser = $rowarray["idUser"];
		$m_idItemSound = $rowarray["idItemSound"];
		$m_dtDownloadTime = $rowarray["dtDownloadTime"];
		$m_idDownloadAreaCode = $rowarray["idDownloadAreaCode"];
*/
		$stat = new CDownloadStatistic(&$rowarray);
/*
		$m_id = $stat->GetId();
		$m_idUser =  $stat->GetIdUser();
		$m_idItemSound = $stat->GetIdItemSound();
		$m_dtDownloadTime = $stat->GetDownloadTime();
		$m_idDownloadAreaCode = $stat->GetDownloadAreaCode();

		echo "id: $m_id<br>";
		echo "idUser: $m_idUser<br>";
		echo "idItemSound: $m_idItemSound<br>";
		echo "dtDownloadTime: $m_dtDownloadTime<br>";
		echo "idDownloadAreaCode: $m_idDownloadAreaCode</FONT><br>";
 */
		return $stat;
	}
	else
	{
	   echo "Error: couldng lock statistics record.<br>";
	}
}



//---------------------------------------------------------------------------------
// open link to db
//---------------------------------------------------------------------------------
$db = new CDatabase($g_strHost, $g_strDbName, $g_strLogin, $g_strPwd);	
$dblink = $db->Connect();

?>
