# phpMyAdmin SQL Dump
# version 2.5.5-pl1
# http://www.phpmyadmin.net
#
# Host: localhost
# Erstellungszeit: 04. Juni 2004 um 14:41
# Server Version: 3.23.58
# PHP-Version: 4.2.2
# 
# Datenbank: `microswapper`
# 

# --------------------------------------------------------

#
# Tabellenstruktur fr Tabelle `dbo_tbTalk`
#

CREATE TABLE `dbo_tbTalk` (
  `sender` int(11) NOT NULL default '0',
  `reciever` int(11) NOT NULL default '0',
  `message` longtext NOT NULL,
  `date` datetime NOT NULL default '0000-00-00 00:00:00',
  `messageId` int(11) NOT NULL auto_increment,
  `sent` varchar(5) NOT NULL default '',
  `recieved` datetime default NULL,
  PRIMARY KEY  (`messageId`,`date`),
  KEY `reciever_index` (`reciever`),
  KEY `sent` (`sent`),
  KEY `recieved` (`recieved`)
) TYPE=MyISAM AUTO_INCREMENT=1 ;



# --------------------------------------------------------

#
# Tabellenstruktur fr Tabelle `dbo_tbUser`
#

CREATE TABLE `dbo_tbUser` (
  `id` int(11) NOT NULL auto_increment,
  `strName` varchar(20) default NULL,
  `nLevel` int(11) default NULL,
  `strPassword` varchar(64) default NULL,
  `dtActivated` datetime NOT NULL default '0000-00-00 00:00:00',
  `dtDeactivated` datetime NOT NULL default '0000-00-00 00:00:00',
  `strEmail` varchar(255) NOT NULL default '',
  `strInfos` longtext NOT NULL,
  `nGuestBlock` tinyint(4) NOT NULL default '0',
  `dtLastLogin` datetime NOT NULL default '0000-00-00 00:00:00',
  UNIQUE KEY `id` (`id`)
) TYPE=MyISAM AUTO_INCREMENT=9692 ;

#
# Daten fr Tabelle `dbo_tbUser`
#

INSERT INTO `dbo_tbUser` VALUES (1, 'carl', 100, 'carl', '1999-08-08 21:34:01', '0000-00-00 00:00:00', 'carl@micromusic.net', '1', 0, '2004-06-04 14:18:53');
INSERT INTO `dbo_tbUser` VALUES (6, 'guest', 0, 'guest', '1999-08-08 21:35:38', '0000-00-00 00:00:00', 'guest@nobody.org', '1', 0, '2003-10-08 23:23:48');
INSERT INTO `dbo_tbUser` VALUES (4, 'hans', 100, 'hans', '1999-08-08 21:35:38', '0000-00-00 00:00:00', 'hans@ubermorgen.com', '4', 0, '2004-06-04 14:36:43');

# --------------------------------------------------------

#
# Tabellenstruktur fr Tabelle `tbAccessLog`
#

CREATE TABLE `tbAccessLog` (
  `id` int(11) NOT NULL auto_increment,
  `dtLoginTime` datetime NOT NULL default '0000-00-00 00:00:00',
  `strLoginCode` varchar(40) NOT NULL default '',
  `dtLastActivity` datetime NOT NULL default '0000-00-00 00:00:00',
  `dtLogoutTime` datetime NOT NULL default '0000-00-00 00:00:00',
  `idUser` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `login_code_index` (`strLoginCode`(10)),
  KEY `idUser` (`idUser`)
) TYPE=MyISAM AUTO_INCREMENT=1 ;

